////////////////////////////////////////////////////////////////////////////////
//
//  string "" a rozsah <k,p> je npos (nenalezeno)
//
//  int Search(kde,co),   vector<int> SearchAll(kde,co)
//    -1 ~ nenalezeno
//
//  StrTake(odkud,poc,kon)
//    poc, kon jsou bu etzce, nebo pozice
//    kon je imlicitn przdn etzec nebo -1, co odpovd konci "odkud"
//    4. argument jsou vlajky:
//       Cut(inplic), Copy, End ~ do=konec, Begin ~ od=zatek
//    okrajov hodnoty do intervalu pat <p,k>
//    PRIKLADY:
//      StrTake (odkud,poc)         // vyjme "poc" z "odkud"
//      StrTake (odkud,poc,"",End)  // vyjme interval <odkud,konec>
//
//  StrAdd(kam,co,zaco/predco)
//    4. argument jsou vlajky:
//       End(implic) ~ zaco, Begin ~ predco
//
//  Replace(kde,co,cim)
//    4. argument jsou vlajky:
//       Vse(implic), int ~ maximln poet nahrazen
//
////////////////////////////////////////////////////////////////////////////////
#ifndef String_h
#define String_h
#include <string>
#include <vector>
#include <BK/Flags.h> // bool Flags(flags,flag)
using std::string;
using std::vector;

//****************************************************************************//
//                          S  E  A  R  C  H                                  //
//****************************************************************************//
int Search(const string& kde, const string& co)
{ int k = kde.size();
  int c = co.size();

  if (c > k) return -1;
  
  for (int i=0; i<=k-c; i++)
    for (int j=0; j<c; j++)
    { if (kde[i+j] != co[j]) break;
      if (j == c-1) return i;
    }
  return -1;
}

vector<int> SearchAll(const string& kde, const string& co)
{ vector<int> out;
  int k = kde.size();
  int c = co.size();

  if (c > k) return out;
  
  for (int i=0; i<=k-c; i++)
    for (int j=0; j<c; j++)
    { if (kde[i+j] != co[j]) break;
      if (j == c-1) out.push_back(i);
    }
  return out;
}

//****************************************************************************//
//                            T   A   K   E                                   //
//****************************************************************************//
  #define Copy   1
  #define Begin  2
  #define End    4 // End+End = 8 ~ Pidej pln na konec
  #define TakeIn 16
  #define CutAll 32
string StrTake(string& odkud, int npoc, int nkon=-1, int flags=0)
{ if( odkud.size()==0 | npoc<0 ) return "";
  if( nkon<0 | Flags(flags,End) ) nkon=odkud.size()-1;
  
  string out;
  for( int i=0; i<odkud.size(); i++ )
    if( i>=npoc & nkon>=i ) out.push_back(odkud[i]);
  
  // imlicitn Cut
  if( !Flags(flags,Copy) )
  { string odkud_pom;
    for( int i=0; i<odkud.size(); i++ )
      if( i<npoc | i>nkon ) odkud_pom.push_back(odkud[i]);
    odkud = odkud_pom;  }

  return out;
}

string StrTake(string& odkud, const string& spoc, const string& skon="", int flags=0)
{ int npoc = Search(odkud,spoc);
  int nkon;
  if( skon.size()!=0 ) nkon = Search(odkud,skon);
    else nkon = npoc+spoc.size();
  nkon = nkon+skon.size()-1;

  if( Flags(flags,TakeIn) )
  { if(npoc!=-1) npoc = npoc+spoc.size();
    nkon = nkon-skon.size();
  }
  string out = StrTake(odkud,npoc,nkon,flags);

  if( Flags(flags,CutAll) )
  { StrTake(odkud,spoc);
    StrTake(odkud,skon);
  }

  return out;
}

//****************************************************************************//
//                            A   D   D                                       //
//****************************************************************************//
string StrAdd(string& kam, const string& co, int nzaco=-1, int flags=End)
{ if( kam.size()==0 ) return "";
  if( nzaco<0 | Flags(flags,End+End) ) nzaco = kam.size()-1;
  string out;

  for( int i=0; i<kam.size(); i++ )
  { if( !Flags(flags,Begin) ) out.push_back(kam[i]);
    if( nzaco==i )
      for( int j=0; j<co.size(); j++ ) out.push_back(co[j]);
    if(  Flags(flags,Begin) ) out.push_back(kam[i]);
  }

  return out;
}

string StrAdd(string& kam, const string& co, const string& zaco, int flags=End)
{ int n = Search(kam,zaco);
  if( n<0 ) return kam;
  if( Flags(flags,End) ) n += zaco.size()-1;
  string out = StrAdd(kam,co,n,flags);
  return out;
}

//****************************************************************************//
//                        R  E  P  L  A  C  E                                 //
//****************************************************************************//
#define Vse    0
bool Replace ( string& kde, const string& co, const string& cim="", int flags=Vse )
{ bool out=0;     int i=0;
  while( Search(kde,co)>=0 )
  { out=1;     i++;
    kde = StrAdd( kde,cim,co );
    StrTake( kde,co );
    if( i==flags ) break;
  }
  return out;
}

//****************************************************************************//
//                           O D V O Z E N E                                  //
//****************************************************************************//
bool JeNaKonci ( const string& ceho, const string& co )
{ vector<int> v = SearchAll(ceho,co);
  if( v.size()==0 ) return 0;
  return v[v.size()-1]==ceho.size()-co.size();
}

#endif
